#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
## ----------------------------------
## TP cc
## Etudiant 1: 
## Etudiant 2: 
## ----------------------------------
import string
from collections import deque
import sys 


##  fonction de chargement de lexique
##  le lexique est un sous-ensemble de mots du fichier en entrée 'fichier'
##  tel que les mots extraits ont la même longueur que le mot en entrée 'mot'
##  input : 'fichier' et 'mot'
##  output : la fonction retourne le lexique de mots  sous forme de liste de string
def lexique_meme_taille(fichier, mot):
    return set(m for m in open(fichier).read().splitlines() if len(m) == len(mot))
    
    
##  fonction de chargement de lexique
##  le lexique est l'ensemble de mots du fichier en entrée 'fichier'
##  la fonction retourne le lexique de mots sous forme de liste de string
##  input : 'fichier'
##  output : la fonction retourne le lexique de mots  sous forme de liste de string
def lexique_complet(fichier):
    return set(m for m in open(fichier).read().splitlines() if len(m) <= 5)
 
##  fonction qui génère les suivants potentiels dans la chaine
##  ici, la règle appliquée est celle qui autorise à chaîner les
##  les mots qui ont une lettre de différence.
##  Cette fonctione génère tous les mots possibles, en remplacant la première
##  par les 25 autres de l'alphabet, puis la deuxième, etc.
##  pour un mot de 4 lettres, on va donc générer 100 mots, dont une bonne part
##  seront fictifs.
##  input : le mot à qui l'on veut trouver les suivants potentiels
##  ouput : une liste de mots potentiels 
def suivant_potentiel(mot_pere):
    combinaisons = set()
    for i in range(len(mot_pere)): # parcours des lettres du mote père
        combinaisons.add(mot_pere[:i]+mot_pere[i+1:]) # -1 lettre
        for l in string.ascii_lowercase: # parcours des lettres
            if l != mot_pere[i]: # changement d'une lettre
                combinaisons.add(mot_pere[:i] + l + mot_pere[i+1:])
            combinaisons.add(mot_pere[:i]+l+mot_pere[i:]) # +1 lettre
    print "nb de mots suivants potentiels "+ str(len(combinaisons)) + " pour mot pere = "+ mot_pere
    return combinaisons
  
##  fonction qui sélectionne les vrais mots, i.e. ceux du lexique.txt, parmi les mots générés
##  par la fonction suivant_potentiel(mot_pere), mots pour la plupart fictifs.
##  fait l'intersection des mots générés (ensemble des suivants potentiels) et des vrais mots.
##  input : le lexique de "vrais" mots
##  ouput : un dict (object python) donnant pour un mot, les mots suivants présents dans le lexique 
def dict_graph(dico):
    
    def vrais_suivants(mot_pere):
        return dico & suivant_potentiel(mot_pere)
          
    return {mot_pere: vrais_suivants(mot_pere) for mot_pere in dico}
  

def djikstra(d, mot1, mot2):
    parent = {}
    keys = {}
    keys[mot1] = 0

    changed = [mot1,]
    while changed:
        mot = changed.pop(0)
        for neighbour in d[mot]:
            dist = abs(len(mot) - len(neighbour))
            if neighbour in keys and keys[neighbour] <= keys[mot]+dist:
                pass
            else:
                if neighbour not in changed:
                    changed.append(neighbour)
                keys[neighbour] = keys[mot]+dist
                parent[neighbour] = mot

    if mot2 not in keys:
        print "there's no path"
    else:
        cn = mot2
        path = [mot2, ]
        while cn in parent:
            cn = parent[cn]
            path.insert(0,cn)
        return path



        


def bfs(d, mot1, mot2):
    to_be_tested = [mot1, ]
    tested = []
    parent = {}

    while to_be_tested:
        mot = to_be_tested.pop(0)
        tested.append(mot)
        for neighbour in d[mot]:
            if neighbour not in tested and neighbour not in to_be_tested:
                to_be_tested.append(neighbour)
                parent[neighbour] = mot

                if neighbour == mot2:
                    # On a trouvé le mot cherché !
                    path = [mot2, ]
                    mot_courant = mot2
                    while mot_courant in parent:
                        mot_courant = parent[mot_courant]
                        path.insert(0, mot_courant)
                    return path
    print "Il n'y a pas de chemin entre %s et %s" % (mot1, mot2)
    return []
 

## --------------------  MAIN -------------------- ##

## Interaction avec l'utilisateur
## L'utilisateur doit entrer deux mots   
mot1 = raw_input("Entrez le mot 1 puis touche <Entree> : ")
mot2 = raw_input("Entrez le mot 2 puis touche <Entree> : ")
#mot2 = "reach"
#mot1 = "boot"

## Chargement du lexique
#mots = lexique_meme_taille("lexique.txt",mot1)
mots = lexique_complet("lexique.txt")

print "Le lexique extrait contient " + str(len(mots)) + " mots"
  
if mot1 not in mots or mot2 not in mots:
    print('L\'un au moins des mots entrés est inconnu.')
    sys.exit(0)
  
#d_meme_taille = dict_graph(mots)
d = dict_graph(mots)
print "Graph created"
  
## C'est à vous !
#result=bfs(d_meme_taille, mot1, mot2)

result=djikstra(d, mot1, mot2)

  


## Le résultat attendu est une liste de mots
print("Enchainement des mots trouvé")
if result is not None:
    print('\n'.join(result))
else:
    print('Aucune transformation trouvée pour passer de mot1 à mot2.')
